Subject: Re: [PATCH v5 0/4] Optimize guix search

From: Arun Isaac <[email-masked]>
Date: Mon, 01 Jun 2020 07:54:06 +0530

> Based on the Ludo's comments [1] on v4 which is a simple re-write of
> your v3, I am finishing a vN+1.. but time flies and I am late on the
> topic too. :-)
>
> Well, this still unsent vN+1 series has the same performance of v4 on
> "guix pull" which is a key point compared to v3.  Obviously, the
> performance on "guix search" are equivalent on both version.  This
> vN+1 builds two caches -- to avoid binary breakage -- in only one go;
> the consuming 'fold-modules-public-variables*' is applied only once.

Interesting, I'll be waiting for your patchset. :-)

> [1] http://issues.guix.gnu.org/39258#93

>> Here's a rough performance comparison.
>
> On cold or warm cache?

On a warm cache.

> So in the best case, you have the ratio old/new is 1.5; this new
> version is 1.5 faster.
>
> Well, in the extra cache approach (v3 or v4) the ration old/new is
> really higher: 3.1 faster on cold cache (which is the one I am
> interested in) and 2.4 faster on warm cache.

We could always have both my optimizations and your improved cache. So,
that's a win on both fronts.

> I will give a look to this new series and report what happens on my
> laptop.  But basically, I would like "guix search" under the 1.0
> second on my machine. ;-)

Indeed, I would love that too! :-)